diff a/src/hotspot/share/gc/shenandoah/vmStructs_shenandoah.hpp b/src/hotspot/share/gc/shenandoah/vmStructs_shenandoah.hpp
--- a/src/hotspot/share/gc/shenandoah/vmStructs_shenandoah.hpp
+++ b/src/hotspot/share/gc/shenandoah/vmStructs_shenandoah.hpp
@@ -23,19 +23,22 @@
  */
 #ifndef SHARE_GC_SHENANDOAH_VMSTRUCTS_SHENANDOAH_HPP
 #define SHARE_GC_SHENANDOAH_VMSTRUCTS_SHENANDOAH_HPP
 
 #include "gc/shenandoah/shenandoahHeap.hpp"
+#include "gc/shenandoah/shenandoahGeneration.hpp"
+#include "gc/shenandoah/shenandoahGenerationalHeap.hpp"
 #include "gc/shenandoah/shenandoahHeapRegion.hpp"
 #include "gc/shenandoah/shenandoahMonitoringSupport.hpp"
 
 #define VM_STRUCTS_SHENANDOAH(nonstatic_field, volatile_nonstatic_field, static_field)                \
   nonstatic_field(ShenandoahHeap, _num_regions,                    size_t)                            \
   nonstatic_field(ShenandoahHeap, _regions,                        ShenandoahHeapRegion**)            \
   nonstatic_field(ShenandoahHeap, _log_min_obj_alignment_in_bytes, int)                               \
-  volatile_nonstatic_field(ShenandoahHeap, _used,                  size_t)                            \
+  nonstatic_field(ShenandoahHeap, _global_generation,              ShenandoahGeneration*)             \
   volatile_nonstatic_field(ShenandoahHeap, _committed,             size_t)                            \
+  volatile_nonstatic_field(ShenandoahGeneration, _used,            size_t)                            \
   static_field(ShenandoahHeapRegion, RegionSizeBytes,              size_t)                            \
   static_field(ShenandoahHeapRegion, RegionSizeBytesShift,         size_t)                            \
   nonstatic_field(ShenandoahHeapRegion, _state,                    ShenandoahHeapRegion::RegionState) \
   nonstatic_field(ShenandoahHeapRegion, _index,                    size_t const)                      \
   nonstatic_field(ShenandoahHeapRegion, _bottom,                   HeapWord* const)                   \
@@ -56,11 +59,14 @@
 
 #define VM_TYPES_SHENANDOAH(declare_type,                                     \
                             declare_toplevel_type,                            \
                             declare_integer_type)                             \
   declare_type(ShenandoahHeap, CollectedHeap)                                 \
+  declare_type(ShenandoahGenerationalHeap, ShenandoahHeap)                    \
   declare_toplevel_type(ShenandoahHeapRegion)                                 \
   declare_toplevel_type(ShenandoahHeap*)                                      \
   declare_toplevel_type(ShenandoahHeapRegion*)                                \
   declare_toplevel_type(ShenandoahHeapRegion::RegionState)                    \
+  declare_toplevel_type(ShenandoahGeneration)                                 \
+  declare_toplevel_type(ShenandoahGeneration*)                                \
 
 #endif // SHARE_GC_SHENANDOAH_VMSTRUCTS_SHENANDOAH_HPP
diff a/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/gc/shenandoah/ShenandoahGeneration.java b/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/gc/shenandoah/ShenandoahGeneration.java
--- /dev/null
+++ b/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/gc/shenandoah/ShenandoahGeneration.java
@@ -0,0 +1,59 @@
+/*
+ * * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+package sun.jvm.hotspot.gc.shenandoah;
+
+import sun.jvm.hotspot.utilities.Observable;
+import sun.jvm.hotspot.utilities.Observer;
+
+import sun.jvm.hotspot.debugger.Address;
+import sun.jvm.hotspot.runtime.VM;
+import sun.jvm.hotspot.runtime.VMObject;
+import sun.jvm.hotspot.types.CIntegerField;
+import sun.jvm.hotspot.types.Type;
+import sun.jvm.hotspot.types.TypeDataBase;
+
+public class ShenandoahGeneration extends VMObject {
+    private static CIntegerField used;
+    static {
+        VM.registerVMInitializedObserver(new Observer() {
+            public void update(Observable o, Object data) {
+                initialize(VM.getVM().getTypeDataBase());
+            }
+        });
+    }
+
+    private static synchronized void initialize(TypeDataBase db) {
+        Type type = db.lookupType("ShenandoahGeneration");
+        used = type.getCIntegerField("_used");
+    }
+
+    public ShenandoahGeneration(Address addr) {
+        super(addr);
+    }
+
+    public long used() {
+        return used.getValue(addr);
+    }
+}
diff a/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/gc/shenandoah/ShenandoahGenerationalHeap.java b/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/gc/shenandoah/ShenandoahGenerationalHeap.java
--- /dev/null
+++ b/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/gc/shenandoah/ShenandoahGenerationalHeap.java
@@ -0,0 +1,33 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+package sun.jvm.hotspot.gc.shenandoah;
+
+import sun.jvm.hotspot.debugger.Address;
+
+public class ShenandoahGenerationalHeap extends ShenandoahHeap {
+    public ShenandoahGenerationalHeap(Address addr) {
+        super(addr);
+    }
+}
diff a/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/gc/shenandoah/ShenandoahHeap.java b/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/gc/shenandoah/ShenandoahHeap.java
--- a/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/gc/shenandoah/ShenandoahHeap.java
+++ b/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/gc/shenandoah/ShenandoahHeap.java
@@ -41,11 +41,11 @@
 import sun.jvm.hotspot.utilities.Observable;
 import sun.jvm.hotspot.utilities.Observer;
 
 public class ShenandoahHeap extends CollectedHeap {
     private static CIntegerField numRegions;
-    private static CIntegerField used;
+    private static AddressField  globalGeneration;
     private static CIntegerField committed;
     private static AddressField  regions;
     private static CIntegerField logMinObjAlignmentInBytes;
 
     private static long regionPtrFieldSize;
@@ -58,11 +58,11 @@
     }
 
     private static synchronized void initialize(TypeDataBase db) {
         Type type = db.lookupType("ShenandoahHeap");
         numRegions = type.getCIntegerField("_num_regions");
-        used = type.getCIntegerField("_used");
+        globalGeneration = type.getAddressField("_global_generation");
         committed = type.getCIntegerField("_committed");
         regions = type.getAddressField("_regions");
         logMinObjAlignmentInBytes = type.getCIntegerField("_log_min_obj_alignment_in_bytes");
 
         Type regionPtrType = db.lookupType("ShenandoahHeapRegion*");
@@ -87,11 +87,13 @@
         return numOfRegions() * ShenandoahHeapRegion.regionSizeBytes();
     }
 
     @Override
     public long used() {
-        return used.getValue(addr);
+        Address globalGenerationAddress = globalGeneration.getValue(addr);
+        ShenandoahGeneration global = VMObjectFactory.newObject(ShenandoahGeneration.class, globalGenerationAddress);
+        return global.used();
     }
 
     public long committed() {
         return committed.getValue(addr);
     }
diff a/test/hotspot/gtest/gc/shenandoah/test_shenandoahNumberSeq.cpp b/test/hotspot/gtest/gc/shenandoah/test_shenandoahNumberSeq.cpp
--- a/test/hotspot/gtest/gc/shenandoah/test_shenandoahNumberSeq.cpp
+++ b/test/hotspot/gtest/gc/shenandoah/test_shenandoahNumberSeq.cpp
@@ -1,8 +1,8 @@
 /*
+ * Copyright (c) 2022, 2023, Oracle and/or its affiliates. All rights reserved.
  * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
- * Copyright (c) 2022, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -32,47 +32,132 @@
 
 #include "unittest.hpp"
 
 class ShenandoahNumberSeqTest: public ::testing::Test {
  protected:
-  HdrSeq seq;
+  const double err = 0.5;
+
+  HdrSeq seq1;
+  HdrSeq seq2;
+  HdrSeq seq3;
+
+  void print() {
+    if (seq1.num() > 0) {
+      print(seq1, "seq1");
+    }
+    if (seq2.num() > 0) {
+      print(seq2, "seq2");
+    }
+    if (seq3.num() > 0) {
+      print(seq3, "seq3");
+    }
+  }
+
+  void print(HdrSeq& seq, const char* msg) {
+    std::cout << "[";
+    for (int i = 0; i <= 100; i += 10) {
+      std::cout << "\t" << seq.percentile(i);
+    }
+    std::cout << " ] : " << msg << "\n";
+  }
 };
 
 class BasicShenandoahNumberSeqTest: public ShenandoahNumberSeqTest {
- protected:
-  const double err = 0.5;
+ public:
   BasicShenandoahNumberSeqTest() {
-    seq.add(0);
-    seq.add(1);
-    seq.add(10);
+    seq1.add(0);
+    seq1.add(1);
+    seq1.add(10);
     for (int i = 0; i < 7; i++) {
-      seq.add(100);
+      seq1.add(100);
+    }
+    ShenandoahNumberSeqTest::print();
+  }
+};
+
+class ShenandoahNumberSeqMergeTest: public ShenandoahNumberSeqTest {
+ public:
+  ShenandoahNumberSeqMergeTest() {
+    for (int i = 0; i < 80; i++) {
+      seq1.add(1);
+      seq3.add(1);
     }
-    std::cout << " p0 = " << seq.percentile(0);
-    std::cout << " p10 = " << seq.percentile(10);
-    std::cout << " p20 = " << seq.percentile(20);
-    std::cout << " p30 = " << seq.percentile(30);
-    std::cout << " p50 = " << seq.percentile(50);
-    std::cout << " p80 = " << seq.percentile(80);
-    std::cout << " p90 = " << seq.percentile(90);
-    std::cout << " p100 = " << seq.percentile(100);
+
+    for (int i = 0; i < 20; i++) {
+      seq2.add(100);
+      seq3.add(100);
+    }
+    ShenandoahNumberSeqTest::print();
   }
 };
 
 TEST_VM_F(BasicShenandoahNumberSeqTest, maximum_test) {
-  EXPECT_EQ(seq.maximum(), 100);
+  EXPECT_EQ(seq1.maximum(), 100);
 }
 
 TEST_VM_F(BasicShenandoahNumberSeqTest, minimum_test) {
-  EXPECT_EQ(0, seq.percentile(0));
+  EXPECT_EQ(0, seq1.percentile(0));
 }
 
 TEST_VM_F(BasicShenandoahNumberSeqTest, percentile_test) {
-  EXPECT_NEAR(0, seq.percentile(10), err);
-  EXPECT_NEAR(1, seq.percentile(20), err);
-  EXPECT_NEAR(10, seq.percentile(30), err);
-  EXPECT_NEAR(100, seq.percentile(40), err);
-  EXPECT_NEAR(100, seq.percentile(50), err);
-  EXPECT_NEAR(100, seq.percentile(75), err);
-  EXPECT_NEAR(100, seq.percentile(90), err);
-  EXPECT_NEAR(100, seq.percentile(100), err);
+  EXPECT_NEAR(0, seq1.percentile(10), err);
+  EXPECT_NEAR(1, seq1.percentile(20), err);
+  EXPECT_NEAR(10, seq1.percentile(30), err);
+  EXPECT_NEAR(100, seq1.percentile(40), err);
+  EXPECT_NEAR(100, seq1.percentile(50), err);
+  EXPECT_NEAR(100, seq1.percentile(75), err);
+  EXPECT_NEAR(100, seq1.percentile(90), err);
+  EXPECT_NEAR(100, seq1.percentile(100), err);
+}
+
+TEST_VM_F(BasicShenandoahNumberSeqTest, clear_test) {
+  HdrSeq test;
+  test.add(1);
+
+  EXPECT_NE(test.num(), 0);
+  EXPECT_NE(test.sum(), 0);
+  EXPECT_NE(test.maximum(), 0);
+  EXPECT_NE(test.avg(), 0);
+  EXPECT_EQ(test.sd(), 0);
+  EXPECT_NE(test.davg(), 0);
+  EXPECT_EQ(test.dvariance(), 0);
+  for (int i = 0; i <= 100; i += 10) {
+    EXPECT_NE(test.percentile(i), 0);
+  }
+
+  test.clear();
+
+  EXPECT_EQ(test.num(), 0);
+  EXPECT_EQ(test.sum(), 0);
+  EXPECT_EQ(test.maximum(), 0);
+  EXPECT_EQ(test.avg(), 0);
+  EXPECT_EQ(test.sd(), 0);
+  EXPECT_EQ(test.davg(), 0);
+  EXPECT_EQ(test.dvariance(), 0);
+  for (int i = 0; i <= 100; i += 10) {
+    EXPECT_EQ(test.percentile(i), 0);
+  }
+}
+
+TEST_VM_F(ShenandoahNumberSeqMergeTest, merge_test) {
+  EXPECT_EQ(seq1.num(), 80);
+  EXPECT_EQ(seq2.num(), 20);
+  EXPECT_EQ(seq3.num(), 100);
+
+  HdrSeq merged;
+  merged.add(seq1);
+  merged.add(seq2);
+
+  EXPECT_EQ(merged.num(), seq3.num());
+
+  EXPECT_EQ(merged.maximum(), seq3.maximum());
+  EXPECT_EQ(merged.percentile(0), seq3.percentile(0));
+  for (int i = 0; i <= 100; i += 10) {
+    EXPECT_NEAR(merged.percentile(i), seq3.percentile(i), err);
+  }
+  EXPECT_NEAR(merged.avg(), seq3.avg(), err);
+  EXPECT_NEAR(merged.sd(),  seq3.sd(),  err);
+
+  // These are not implemented
+  EXPECT_TRUE(isnan(merged.davg()));
+  EXPECT_TRUE(isnan(merged.dvariance()));
 }
diff a/test/hotspot/gtest/gc/shenandoah/test_shenandoahOldGeneration.cpp b/test/hotspot/gtest/gc/shenandoah/test_shenandoahOldGeneration.cpp
--- /dev/null
+++ b/test/hotspot/gtest/gc/shenandoah/test_shenandoahOldGeneration.cpp
@@ -0,0 +1,200 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+#include "precompiled.hpp"
+#include "unittest.hpp"
+
+#include "gc/shenandoah/shenandoahHeap.inline.hpp"
+#include "gc/shenandoah/mode/shenandoahMode.hpp"
+#include "gc/shenandoah/shenandoahOldGeneration.hpp"
+#include "gc/shenandoah/shenandoahThreadLocalData.hpp"
+
+#define SKIP_IF_NOT_SHENANDOAH() \
+  if (!(UseShenandoahGC && ShenandoahHeap::heap()->mode()->is_generational())) {                 \
+    tty->print_cr("skipped (run with -XX:+UseShenandoahGC -XX:ShenandoahGCMode=generational)");  \
+    return;                                                                                      \
+  }
+
+
+class ShenandoahOldGenerationTest : public ::testing::Test {
+protected:
+  static const size_t INITIAL_PLAB_SIZE;
+  static const size_t INITIAL_PLAB_PROMOTED;
+
+  ShenandoahOldGeneration* old;
+
+  ShenandoahOldGenerationTest()
+    : old(nullptr)
+  {
+  }
+
+  void SetUp() override {
+    SKIP_IF_NOT_SHENANDOAH();
+
+    ShenandoahHeap::heap()->lock()->lock(false);
+
+    old = new ShenandoahOldGeneration(8, 1024 * 1024, 1024);
+    old->set_promoted_reserve(512 * HeapWordSize);
+    old->expend_promoted(256 * HeapWordSize);
+    old->set_evacuation_reserve(512 * HeapWordSize);
+
+    Thread* thread = Thread::current();
+    ShenandoahThreadLocalData::reset_plab_promoted(thread);
+    ShenandoahThreadLocalData::disable_plab_promotions(thread);
+    ShenandoahThreadLocalData::set_plab_actual_size(thread, INITIAL_PLAB_SIZE);
+    ShenandoahThreadLocalData::add_to_plab_promoted(thread, INITIAL_PLAB_PROMOTED);
+  }
+
+  void TearDown() override {
+    if (UseShenandoahGC) {
+      ShenandoahHeap::heap()->lock()->unlock();
+      delete old;
+    }
+  }
+
+  static bool promotions_enabled() {
+    return ShenandoahThreadLocalData::allow_plab_promotions(Thread::current());
+  }
+
+  static size_t plab_size() {
+    return ShenandoahThreadLocalData::get_plab_actual_size(Thread::current());
+  }
+
+  static size_t plab_promoted() {
+    return ShenandoahThreadLocalData::get_plab_promoted(Thread::current());
+  }
+};
+
+const size_t ShenandoahOldGenerationTest::INITIAL_PLAB_SIZE = 42;
+const size_t ShenandoahOldGenerationTest::INITIAL_PLAB_PROMOTED = 128;
+
+TEST_VM_F(ShenandoahOldGenerationTest, test_can_promote) {
+  SKIP_IF_NOT_SHENANDOAH();
+  EXPECT_TRUE(old->can_promote(128 * HeapWordSize)) << "Should have room to promote";
+  EXPECT_FALSE(old->can_promote(384 * HeapWordSize)) << "Should not have room to promote";
+}
+
+TEST_VM_F(ShenandoahOldGenerationTest, test_can_allocate_plab_for_promotion) {
+  SKIP_IF_NOT_SHENANDOAH();
+  ShenandoahAllocRequest req = ShenandoahAllocRequest::for_plab(128, 128);
+  EXPECT_TRUE(old->can_allocate(req)) << "Should have room to promote";
+}
+
+TEST_VM_F(ShenandoahOldGenerationTest, test_can_allocate_plab_for_evacuation) {
+  SKIP_IF_NOT_SHENANDOAH();
+  ShenandoahAllocRequest req = ShenandoahAllocRequest::for_plab(384, 384);
+  EXPECT_FALSE(old->can_promote(req.size() * HeapWordSize)) << "No room for promotions";
+  EXPECT_TRUE(old->can_allocate(req)) << "Should have room to evacuate";
+}
+
+TEST_VM_F(ShenandoahOldGenerationTest, test_cannot_allocate_plab) {
+  SKIP_IF_NOT_SHENANDOAH();
+  // Simulate having exhausted the evacuation reserve when request is too big to be promoted
+  old->set_evacuation_reserve(0);
+  ShenandoahAllocRequest req = ShenandoahAllocRequest::for_plab(384, 384);
+  EXPECT_FALSE(old->can_allocate(req)) << "No room for promotions or evacuations";
+}
+
+TEST_VM_F(ShenandoahOldGenerationTest, test_can_allocate_for_shared_evacuation) {
+  SKIP_IF_NOT_SHENANDOAH();
+  ShenandoahAllocRequest req = ShenandoahAllocRequest::for_shared_gc(768, ShenandoahAffiliation::OLD_GENERATION, false);
+  EXPECT_FALSE(old->can_promote(req.size() * HeapWordSize)) << "No room for promotion";
+  EXPECT_TRUE(old->can_allocate(req)) << "Should have room to evacuate shared (even though evacuation reserve is smaller than request)";
+}
+
+TEST_VM_F(ShenandoahOldGenerationTest, test_cannot_allocate_for_shared_promotion) {
+  SKIP_IF_NOT_SHENANDOAH();
+  ShenandoahAllocRequest req = ShenandoahAllocRequest::for_shared_gc(768, ShenandoahAffiliation::OLD_GENERATION, true);
+  EXPECT_FALSE(old->can_promote(req.size() * HeapWordSize)) << "No room for promotion";
+  EXPECT_FALSE(old->can_allocate(req)) << "No room to promote, should fall back to evacuation in young gen";
+}
+
+TEST_VM_F(ShenandoahOldGenerationTest, test_expend_promoted) {
+  SKIP_IF_NOT_SHENANDOAH();
+  ShenandoahAllocRequest req = ShenandoahAllocRequest::for_plab(128, 128);
+
+  // simulate the allocation
+  req.set_actual_size(128);
+
+  size_t actual_size = req.actual_size() * HeapWordSize;
+  EXPECT_TRUE(old->can_promote(actual_size)) << "Should have room for promotion";
+
+  size_t expended_before = old->get_promoted_expended();
+  old->configure_plab_for_current_thread(req);
+  size_t expended_after = old->get_promoted_expended();
+  EXPECT_EQ(expended_before + actual_size, expended_after) << "Should expend promotion reserve";
+  EXPECT_EQ(plab_promoted(), 0UL) << "Nothing promoted yet";
+  EXPECT_EQ(plab_size(), actual_size) << "New plab should be able to hold this much promotion";
+  EXPECT_TRUE(promotions_enabled()) << "Plab should be available for promotions";
+}
+
+TEST_VM_F(ShenandoahOldGenerationTest, test_actual_size_exceeds_promotion_reserve) {
+  SKIP_IF_NOT_SHENANDOAH();
+  ShenandoahAllocRequest req = ShenandoahAllocRequest::for_plab(128, 128);
+
+  // simulate an allocation that exceeds the promotion reserve after allocation
+  req.set_actual_size(384);
+  EXPECT_FALSE(old->can_promote(req.actual_size() * HeapWordSize)) << "Should have room for promotion";
+
+  size_t expended_before = old->get_promoted_expended();
+  old->configure_plab_for_current_thread(req);
+  size_t expended_after = old->get_promoted_expended();
+
+  EXPECT_EQ(expended_before, expended_after) << "Did not promote, should not expend promotion";
+  EXPECT_EQ(plab_promoted(), 0UL) << "Cannot promote in new plab";
+  EXPECT_EQ(plab_size(), 0UL) << "Should not have space for promotions";
+  EXPECT_FALSE(promotions_enabled()) << "New plab can only be used for evacuations";
+}
+
+TEST_VM_F(ShenandoahOldGenerationTest, test_shared_expends_promoted_but_does_not_change_plab) {
+  SKIP_IF_NOT_SHENANDOAH();
+  ShenandoahAllocRequest req = ShenandoahAllocRequest::for_shared_gc(128, ShenandoahAffiliation::OLD_GENERATION, true);
+  req.set_actual_size(128);
+  size_t actual_size = req.actual_size() * HeapWordSize;
+
+  size_t expended_before = old->get_promoted_expended();
+  old->configure_plab_for_current_thread(req);
+  size_t expended_after = old->get_promoted_expended();
+
+  EXPECT_EQ(expended_before + actual_size, expended_after) << "Shared promotion still expends promotion";
+  EXPECT_EQ(plab_promoted(), INITIAL_PLAB_PROMOTED) << "Shared promotion should not count in plab";
+  EXPECT_EQ(plab_size(), INITIAL_PLAB_SIZE) << "Shared promotion should not change size of plab";
+  EXPECT_FALSE(promotions_enabled());
+}
+
+TEST_VM_F(ShenandoahOldGenerationTest, test_shared_evacuation_has_no_side_effects) {
+  SKIP_IF_NOT_SHENANDOAH();
+  ShenandoahAllocRequest req = ShenandoahAllocRequest::for_shared_gc(128, ShenandoahAffiliation::OLD_GENERATION, false);
+  req.set_actual_size(128);
+
+  size_t expended_before = old->get_promoted_expended();
+  old->configure_plab_for_current_thread(req);
+  size_t expended_after = old->get_promoted_expended();
+
+  EXPECT_EQ(expended_before, expended_after) << "Not a promotion, should not expend promotion reserve";
+  EXPECT_EQ(plab_promoted(), INITIAL_PLAB_PROMOTED) << "Not a plab, should not have touched plab";
+  EXPECT_EQ(plab_size(), INITIAL_PLAB_SIZE) << "Not a plab, should not have touched plab";
+  EXPECT_FALSE(promotions_enabled());
+}
+
+#undef SKIP_IF_NOT_SHENANDOAH
